/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.muni.fi.pv168.graveyard;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author bar
 */
public class GraveYardDB {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        Connection con = null;
        try{
            con = DriverManager.getConnection("jdbc:derby://localhost:1527/graveyarddb","bar","barbar");
            con.setAutoCommit(false);
            int graveId = -1;
            PreparedStatement insertData = con.prepareStatement("insert into bar.graves(graverow,gravecolumn,family) values(?,?,?)",Statement.RETURN_GENERATED_KEYS);
            insertData.setInt(1, 1);
            insertData.setInt(2, 5);
            insertData.setString(3,"Pati");
            insertData.execute();
            ResultSet res = insertData.getGeneratedKeys();
            if(res.next()){
                graveId = res.getInt(1);
                System.out.println("Vygenerovany klic: " + graveId);
            }
            displayDB(con);
            
            PreparedStatement update = con.prepareStatement("update BAR.GRAVES set family=? where graveid=?");
            update.setString(1, "Johns");
            update.setInt(2, 3);
            int updatedRows = update.executeUpdate();
            System.out.println("Zmeneno " + updatedRows + " zaznamu.");
            
            displayDB(con);
            
            PreparedStatement delete = con.prepareStatement("delete from BAR.graves where graveid=?");
            delete.setInt(1,3);
            int deleted = delete.executeUpdate();
            System.out.println("Smazano "+ deleted + " zaznamu.");
            displayDB(con);
            con.commit();
        } catch (SQLException ex) {
            try {
                if(con!=null){
                    con.rollback();
                }
            } catch (SQLException ex1) {
                Logger.getLogger(GraveYardDB.class.getName()).log(Level.SEVERE, null, ex1);
            }
            Logger.getLogger(GraveYardDB.class.getName()).log(Level.SEVERE, null, ex);
        }finally{
            if(con!=null){
                try {
                    con.close();
                } catch (SQLException ex) {
                    Logger.getLogger(GraveYardDB.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        }
    }

    private static void displayDB(Connection con) throws SQLException {
        PreparedStatement retrieveData = con.prepareStatement("select * from bar.graves");
        ResultSet graves = retrieveData.executeQuery();
        while(graves.next()){
            System.out.print("Rada = " + graves.getInt("graverow")+", ");
            System.out.print("Sloupec = " + graves.getInt("gravecolumn")+", ");
            System.out.println("Vlastnici = " + graves.getString("family"));
        }
    }
}
